pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT > Class Template Reference
Module recognition

Class implementing a 3D correspondence grouping enforcing geometric consistency among feature correspondences. More...

`#include <pcl/recognition/cg/geometric_consistency.h>`

Inheritance diagram for pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >:

## Public Types

typedef pcl::PointCloud< PointModelT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef pcl::CorrespondenceGrouping< PointModelT, PointSceneT >::SceneCloudConstPtr | SceneCloudConstPtr
Public Types inherited from pcl::CorrespondenceGrouping< PointModelT, PointSceneT >
typedef pcl::PointCloud< PointSceneT > | SceneCloud
typedef SceneCloud::Ptr | SceneCloudPtr
typedef SceneCloud::ConstPtr | SceneCloudConstPtr
Public Types inherited from pcl::PCLBase< PointModelT >
typedef pcl::PointCloud< PointModelT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| GeometricConsistencyGrouping ()
| Constructor. More...
void | setGCThreshold (int threshold)
| Sets the minimum cluster size. More...
int | getGCThreshold () const
| Gets the minimum cluster size. More...
void | setGCSize (double gc_size)
| Sets the consensus set resolution. More...
double | getGCSize () const
| Gets the consensus set resolution. More...
bool | recognize (std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > &transformations)
| The main function, recognizes instances of the model into the scene set by the user. More...
bool | recognize (std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > &transformations, std::vector< pcl::Correspondences > &clustered_corrs)
| The main function, recognizes instances of the model into the scene set by the user. More...
Public Member Functions inherited from pcl::CorrespondenceGrouping< PointModelT, PointSceneT >
| CorrespondenceGrouping ()
| Empty constructor. More...
virtual | ~CorrespondenceGrouping ()
| destructor. More...
virtual void | setSceneCloud (const SceneCloudConstPtr &scene)
| Provide a pointer to the scene dataset. More...
SceneCloudConstPtr | getSceneCloud () const
| Getter for the scene dataset. More...
virtual void | setModelSceneCorrespondences (const CorrespondencesConstPtr &corrs)
| Provide a pointer to the precomputed correspondences between points in the input dataset and points in the scene dataset. More...
CorrespondencesConstPtr | getModelSceneCorrespondences () const
| Getter for the precomputed correspondences between points in the input dataset and points in the scene dataset. More...
std::vector< double > | getCharacteristicScales () const
| Getter for the vector of characteristic scales associated to each cluster. More...
void | cluster (std::vector< Correspondences > &clustered_corrs)
| Clusters the input correspondences belonging to different model instances. More...
Public Member Functions inherited from pcl::PCLBase< PointModelT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointModelT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

void | clusterCorrespondences (std::vector< Correspondences > &model_instances)
| Cluster the input correspondences in order to distinguish between different instances of the model into the scene. More...
Protected Member Functions inherited from pcl::CorrespondenceGrouping< PointModelT, PointSceneT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...
Protected Member Functions inherited from pcl::PCLBase< PointModelT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

int | gc_threshold_
| Minimum cluster size. More...
double | gc_size_
| Resolution of the consensus set used to cluster correspondences together. More...
std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > | found_transformations_
| Transformations found by clusterCorrespondences method. More...
Protected Attributes inherited from pcl::CorrespondenceGrouping< PointModelT, PointSceneT >
SceneCloudConstPtr | scene_
| The scene cloud. More...
CorrespondencesConstPtr | model_scene_corrs_
| The correspondences between points in the input and the scene datasets. More...
std::vector< double > | corr_group_scale_
| characteristic scale associated to each correspondence subset; if the cg algorithm can not handle scale invariance, the size of the vector will be 0. More...
Protected Attributes inherited from pcl::PCLBase< PointModelT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointModelT, typename PointSceneT>
class pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >

Class implementing a 3D correspondence grouping enforcing geometric consistency among feature correspondences.

Author
  Federico Tombari, Tommaso Cavallari, Aitor Aldoma

Definition at line 55 of file geometric_consistency.h.

## Member Typedef Documentation

## PointCloud

template<typename PointModelT , typename PointSceneT >

typedef pcl::PointCloud<PointModelT> pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::PointCloud

Definition at line 58 of file geometric_consistency.h.

## PointCloudConstPtr

template<typename PointModelT , typename PointSceneT >

typedef PointCloud::ConstPtr pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::PointCloudConstPtr

Definition at line 60 of file geometric_consistency.h.

## PointCloudPtr

template<typename PointModelT , typename PointSceneT >

typedef PointCloud::Ptr pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::PointCloudPtr

Definition at line 59 of file geometric_consistency.h.

## SceneCloudConstPtr

template<typename PointModelT , typename PointSceneT >

typedef pcl::CorrespondenceGrouping<PointModelT, PointSceneT>::SceneCloudConstPtr pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::SceneCloudConstPtr

Definition at line 62 of file geometric_consistency.h.

## Constructor & Destructor Documentation

## GeometricConsistencyGrouping()

template<typename PointModelT , typename PointSceneT >

pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::GeometricConsistencyGrouping | ( |  | ) |

inline

Constructor.

Definition at line 65 of file geometric_consistency.h.

## Member Function Documentation

## clusterCorrespondences()

template<typename PointModelT , typename PointSceneT >

void pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::clusterCorrespondences | ( | std::vector< Correspondences > & | model_instances | ) |

protected virtual

Cluster the input correspondences in order to distinguish between different instances of the model into the scene.

Parameters

  [out] | model_instances | a vector containing the clustered correspondences for each model found on the scene.

Returns
  true if the clustering had been successful or false if errors have occurred.

Implements pcl::CorrespondenceGrouping< PointModelT, PointSceneT >.

Definition at line 57 of file geometric_consistency.hpp.

References pcl::geometry::distance(), and pcl::registration::CorrespondenceRejectorSampleConsensus< PointT >::setMaximumIterations().

## getGCSize()

template<typename PointModelT , typename PointSceneT >

double pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::getGCSize | ( |  | ) | const

inline

Gets the consensus set resolution.

Returns
  the consensus set resolution.

Definition at line 106 of file geometric_consistency.h.

References pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::gc_size_, and pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::recognize().

## getGCThreshold()

template<typename PointModelT , typename PointSceneT >

int pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::getGCThreshold | ( |  | ) | const

inline

Gets the minimum cluster size.

Returns
  the minimum cluster size used by GC.

Definition at line 86 of file geometric_consistency.h.

References pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::gc_threshold_.

## recognize() [1/2]

template<typename PointModelT , typename PointSceneT >

bool pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::recognize | ( | std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > & | transformations | ) |

The main function, recognizes instances of the model into the scene set by the user.

Parameters

  [out] | transformations | a vector containing one transformation matrix for each instance of the model recognized into the scene.

Returns
  true if the recognition had been successful or false if errors have occurred.

Definition at line 153 of file geometric_consistency.hpp.

Referenced by pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::getGCSize().

## recognize() [2/2]

template<typename PointModelT , typename PointSceneT >

bool pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::recognize | ( | std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > & | transformations,
|  | std::vector< pcl::Correspondences > & | clustered_corrs
| ) |  |

The main function, recognizes instances of the model into the scene set by the user.

Parameters

  [out] | transformations | a vector containing one transformation matrix for each instance of the model recognized into the scene.
  [out] | clustered_corrs | a vector containing the correspondences for each instance of the model found within the input data (the same output of clusterCorrespondences).

Returns
  true if the recognition had been successful or false if errors have occurred.

Definition at line 162 of file geometric_consistency.hpp.

## setGCSize()

template<typename PointModelT , typename PointSceneT >

void pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::setGCSize | ( | double | gc_size | ) |

inline

Sets the consensus set resolution.

This should be in metric units.

Parameters

  [in] | gc_size | consensus set resolution.

Definition at line 96 of file geometric_consistency.h.

References pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::gc_size_.

## setGCThreshold()

template<typename PointModelT , typename PointSceneT >

void pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::setGCThreshold | ( | int | threshold | ) |

inline

Sets the minimum cluster size.

Parameters

  [in] | threshold | the minimum cluster size

Definition at line 76 of file geometric_consistency.h.

References pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::gc_threshold_.

## Member Data Documentation

## found_transformations_

template<typename PointModelT , typename PointSceneT >

std::vector<Eigen::Matrix4f, Eigen::aligned_allocator<Eigen::Matrix4f> > pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::found_transformations_

protected

Transformations found by clusterCorrespondences method.

Definition at line 142 of file geometric_consistency.h.

## gc_size_

template<typename PointModelT , typename PointSceneT >

double pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::gc_size_

protected

Resolution of the consensus set used to cluster correspondences together.

Definition at line 139 of file geometric_consistency.h.

Referenced by pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::getGCSize(), and pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::setGCSize().

## gc_threshold_

template<typename PointModelT , typename PointSceneT >

int pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::gc_threshold_

protected

Minimum cluster size.

It shouldn't be less than 3, since at least 3 correspondences are needed to compute the 6DOF pose

Definition at line 136 of file geometric_consistency.h.

Referenced by pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::getGCThreshold(), and pcl::GeometricConsistencyGrouping< PointModelT, PointSceneT >::setGCThreshold().

The documentation for this class was generated from the following files:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/recognition/include/pcl/recognition/cg/geometric_consistency.h
- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/recognition/include/pcl/recognition/impl/cg/geometric_consistency.hpp